class Rucksack:
    """
    Lösung für das klassische Rucksackproblem
    """
    def __init__(self):
        """
        Legt die Vorratsdaten und die Attribute an.
        """
        self.maximalGewicht = 30
        self.gewichte = [5, 7, 4, 3, 10, 12, 13, 8]
        self.nährwerte = [40, 35, 12, 30, 25, 84, 78, 80]
        self.aktuelleVorräte = []
        self.optimaleVorräte = []
        self.optimalerNährwert = -1
        self.SchrittAusführen(0, 0, 0)
        self.OptimalenVorratAusgeben()

    def OptimumSichern(self, nährwert):
        """
        Speichert den aktuellen Vorrat als optimalen Vorrat.
        :param nährwert: der Gesamtnährwert des gespeicherten Vorrats.
        """
        self.optimaleVorräte = list(self.aktuelleVorräte)
        self.optimalerNährwert = nährwert

    def OptimalenVorratAusgeben(self):
        """
        Gibt den optimalen Vorrat auf die Konsole aus.
        """
        print("Der optimale Vorrat hat den Gesamtnährwert", self.optimalerNährwert, "MJ")
        print("Einzelvorräte:")
        for i in self.optimaleVorräte:
            print(f"Nummer {i}: Gewicht {self.gewichte[i]}kg, Nährwert: {self.nährwerte[i]}MJ")

    def SchrittAusführen(self, startIndex, aktuellesGewicht, aktuellerNährwert):
        """
        Fügt den nächsten Vorrat zu den bisherigen Vorräten hinzu
        :param startIndex: der Index, ab dem die Vorräte ergänzt werden können.
        :param aktuellesGewicht: das Gewicht des bisherigen Vorratsstapels
        :param aktuellerNährwert: der Nährwert des bisherigen Vorratsstapels
        """
        pass

Rucksack()
